/******************** (C) COPYRIGHT 2010 Intersil ********************
* File Name         : proc_entry.h
* Author            : rxchen@intersil.com
* Revision          : 
* Date              : 
* Description       : proc entry
********************************************************************************
* THE PRESENT SOFTWARE IS DISTRIBUTED IN THE HOPE THAT IT WILL PROVIDE CUSTOMERS 
* WITH CODING INFORMATION TO SPEED UP THEIR PRODUCT DEVELOPMENT, BUT WITHOUT
* ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF MERCHANTABILITY OR FITNESS
* FOR A PARTICULAR PURPOSE. AS A RESULT, TECHWELL SHALL NOT BE HELD LIABLE FOR ANY
* DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
* FROM THE CONTENT OF SUCH SOFTWARE AND/OR THE USE MADE BY CUSTOMERS OF THE
* CODING INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*******************************************************************************/

#ifndef __PROC_ENTRY_H__
#define __PROC_ENTRY_H__

#include <linux/version.h>
#define CREATE_PROC_REMOVED KERNEL_VERSION(3, 10, 0)

#ifdef __cplusplus
extern "C"
{
#endif
#ifdef MESSAGE_LOG
    struct message_privte{
	wait_queue_head_t wait;
	spinlock_t lock;

	char *buf;
	u32 buf_len;
	u32 start;
	u32 end;
    };
#endif
    typedef struct {
	char name[64];
	atomic_t ref_count;
	struct proc_dir_entry *entry;
	ssize_t (*read) (struct seq_file *seq, void *);
	ssize_t (*write) (struct file *, const char __user *, size_t, loff_t *);

	void *private;
    }isil_proc_register_s;

#ifdef MESSAGE_LOG
    extern struct message_privte *message_log;
    extern int message_level;
#endif

    void *isil_seq_get_private(struct seq_file *seq);
    void *isil_file_get_seq_private(struct file *file);
    int isil_module_register(isil_chip_t *chip, isil_proc_register_s *reg);
    int isil_module_unregister(isil_chip_t *chip, isil_proc_register_s *reg);
    int proc_module_init(void);
    void proc_module_release(void);

    unsigned int atoi(char *str);
    struct file *isil_kernel_file_open(char *);
    void isil_kernel_file_close(struct file *);


#ifdef __cplusplus
}
#endif

#endif //__PROC_ENTRY_H__

