/******************** (C) COPYRIGHT 2010 Intersil ********************
* File Name          : tc_audio_decode.h
* Author             : zhang zhao
* Revision           : 1.2.1.1289
* Date               : 2012-04-05
* Description        : the header file for audio decode
********************************************************************************
* THE PRESENT SOFTWARE IS DISTRIBUTED IN THE HOPE THAT IT WILL PROVIDE CUSTOMERS 
* WITH CODING INFORMATION TO SPEED UP THEIR PRODUCT DEVELOPMENT, BUT WITHOUT
* ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF MERCHANTABILITY OR FITNESS
* FOR A PARTICULAR PURPOSE. AS A RESULT, TECHWELL SHALL NOT BE HELD LIABLE FOR ANY
* DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
* FROM THE CONTENT OF SUCH SOFTWARE AND/OR THE USE MADE BY CUSTOMERS OF THE
* CODING INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*******************************************************************************/


#ifndef	ISIL_AUDIO_DE_H__
#define	ISIL_AUDIO_DE_H__

#ifdef __cplusplus
extern "C"
{
#endif







#define	ISIL_AUDIO_8K         (0)
#define	ISIL_AUDIO_16K        (1)

#define	ISIL_AUDIO_16BIT      (0)
#define	ISIL_AUDIO_8BIT       (1)

#define	ISIL_AUDIO_PCM        (0)
#define	ISIL_AUDIO_ALAW       (1)
#define	ISIL_AUDIO_ULAW       (2)
#define	ISIL_AUDIO_ADPCM_32K  (3)
#define	ISIL_AUDIO_ADPCM_16K  (4)
#define	ISIL_AUDIO_ADPCM_48K  (5)

#define	AUDIO_ENABLE        (0x0001)
#define	AUDIO_DISABLE       (0x0000)
#define	AUDIO_MUTE_ENABLE   (0x0001)
#define	AUDIO_MUTE_DISABLE  (0x0000)



    typedef enum audio_state
    {
	NEED_INIT = 0,
	INITED,
	OPENED,
	CLOSED,
    }AUDIO_STATE;


    struct audio_en_operation
    {
	int (*init)(struct isil_audio_en *ai);
	//...
    };

    struct isil_audio_config
    {
	int type;
	int sample_rate;
	int bit_wide;
    };

    struct isil_audio_paramts
    {
	struct isil_audio_config    property;
	struct audio_en_operation  *op;
    };

    /*the top struct of audio in*/
    struct isil_audio_de
    {
	struct isil_service_device	tsd;
	char 				*name;
	int 				users;
	AUDIO_STATE			state;
	struct isil_audio_paramts		para;
	isil_audio_driver_t		*ae_driv;
	struct tc_queue			*queue;
	struct semaphore		sem;

    };










#ifdef __cplusplus
}
#endif

#endif
